/* Copyright 2014-2017 Research Foundation State University of New York   */

/* This file is part of QUB Online.                                       */

/* QUB Online is free software; you can redistribute it and/or modify    */
/* it under the terms of the GNU General Public License as published by   */
/* the Free Software Foundation, either version 3 of the License, or      */
/* (at your option) any later version.                                    */

/* QUB Online is distributed in the hope that it will be useful,         */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of         */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          */
/* GNU General Public License for more details.                           */

/* You should have received a copy of the GNU General Public License,     */
/* named LICENSE.txt, in the QUB Online program directory.  If not, see  */
/* <http://www.gnu.org/licenses/>.                                        */


#include <iostream>
using std::cout;
using std::cerr;
using std::endl;
#include <math.h>

#include "qub_mean.h"

QUBFAST_API void    qub_mean_rss(float *data, int N, double *mean, double *rss)
{
  IncrementalRSS calc;
  calc.add_n(data, N);
  *mean = calc.mean;
  *rss = calc.rss;
}

QUBFAST_API void*   qub_mean_rss_init()
{
  return new IncrementalRSS;
}

QUBFAST_API void    qub_mean_rss_free(void *obj)
{
  delete (IncrementalRSS *) obj;
}

QUBFAST_API void    qub_mean_rss_add(void *obj, float *data, int N)
{
  ((IncrementalRSS *) obj)->add_n(data, N);
}

QUBFAST_API int     qub_mean_rss_read(void *obj, double *mean, double *rss)
{
  IncrementalRSS *calc = (IncrementalRSS *) obj;
  *mean = calc->mean;
  *rss = calc->rss;
  return (int) calc->n;
}

